
#include <MPU6050_HT.h>
#include <Wire.h>
#include <Servo.h>


// Configurazione dei parametri PPM
const int PPM_PIN = 1; // Pin digitale per il segnale PPM Attiny85
//const int PPM_PIN = 9; // Pin digitale per il segnale PPM Arduino
const int PPM_FRAME_LENGTH = 20000; // Lunghezza del frame in microsecondi
const int CHANNEL_COUNT = 3; // Numero di canali

// Array per i valori dei canali (in microsecondi)
int channelValues[CHANNEL_COUNT] = {1000, 1000, 1000};

int pin  = 4;
int yaw = 0;    // variable to store the servo position
int pitch = 0;    // variable to store the servo position


MPU6050 mpu6050(Wire);

void setup() {
//  Serial.begin(9600);
  Wire.begin();
  mpu6050.begin();
  mpu6050.calcGyroOffsets(true);
  pinMode(PPM_PIN, OUTPUT);
  pinMode(pin, INPUT_PULLUP);  // Imposta lo switch come input
 
}

void loop() {
  int buttonState = digitalRead(pin);
  mpu6050.update();
  yaw = map(mpu6050.getAngleZ(), -60, 60, 670, 1720);
  pitch = map(mpu6050.getAngleX(), -50, 50, 670, 1720);
  
  channelValues[1] = yaw;
  channelValues[2] = pitch;
  sendPPM();
  delay(20);
   if (buttonState == 1) {
   mpu6050.resetAngles();                    
  }

}



void sendPPM() {
    // Inizio del frame
    digitalWrite(PPM_PIN, HIGH);
    delayMicroseconds(9000); // Tempo di pausa di 9 ms

    // Inviare i valori dei canali
    for (int i = 0; i < CHANNEL_COUNT; i++) {
        digitalWrite(PPM_PIN, HIGH);
        delayMicroseconds(channelValues[i]); // Durata del segnale HIGH per il canale
        digitalWrite(PPM_PIN, LOW);
        delayMicroseconds(300); // Breve pausa tra i canali
    }

    // Fine del frame
    digitalWrite(PPM_PIN, LOW);
    delayMicroseconds(PPM_FRAME_LENGTH - 9000 - (CHANNEL_COUNT * 300)); // Riempimento fino a 20 ms
}
